QEMU-IMG(1)

NAME
qemu-img - QEMU disk image utility

SYNOPSIS
usage: qemu-img command [command options]

DESCRIPTION
qemu-img allows you to create, convert and modify images offline. It can handle all image formats supported by QEMU.

Warning: Never use qemu-img to modify images in use by a running virtual machine or any other process; this may destroy the image. Also, be aware that querying an image that is being modified by another process may encounter inconsistent state.

OPTIONS
The following commands are supported:

check [-f fmt] [-r [leaks | all]] filename
create [-f fmt] [-o options] filename [size]
commit [-f fmt] [-t cache] filename
convert [-c] [-p] [-f fmt] [-t cache] [-O output_fmt] [-o options] [-s snapshot_name] [-S sparse_size] filename [filename2 [...]] output_filename
info [-f fmt] [--output=ofmt] [--backing-chain] filename
snapshot [-l | -a snapshot | -c snapshot | -d snapshot] filename
rebase [-f fmt] [-t cache] [-p] [-u] -b backing_file [-F backing_fmt] filename
resize filename [+ | -]size

Command parameters:

filename
     is a disk image filename

fmt is the disk image format. It is guessed automatically in most cases. See below for a description of the supported disk formats.

--backing-chain
    will enumerate information about backing files in a disk image chain. Refer below for further description.

size
    is the disk image size in bytes. Optional suffixes "k" or "K" (kilobyte, 1024) "M" (megabyte, 1024k) and "G" (gigabyte, 1024M) and T (terabyte, 1024G) are supported. "b" is ignored.

output_filename
    is the destination disk image filename

output_fmt
     is the destination format

options
    is a comma separated list of format specific options in a name=value format. Use "-o ?" for an overview of the options supported by the used format or see the format descriptions below for details.

-c  indicates that target image must be compressed (qcow format only)

-h  with or without a command shows help and lists the supported formats

-p  display progress bar (convert and rebase commands only)

-S size
    indicates the consecutive number of bytes that must contain only zeros for qemu-img to create a sparse image during conversion. This value is rounded down to the nearest 512 bytes. You may use the common size suffixes like "k" for kilobytes.

-t cache
    specifies the cache mode that should be used with the (destination) file. See the documentation of the emulator's "-drive cache=..." option for allowed values.

Parameters to snapshot subcommand:

snapshot
    is the name of the snapshot to create, apply or delete

-a  applies a snapshot (revert disk to saved state)

-c  creates a snapshot

-d  deletes a snapshot

-l  lists all snapshots in the given image

Command description:

check [-f fmt] [-r [leaks | all]] filename
    Perform a consistency check on the disk image filename.

    If "-r" is specified, qemu-img tries to repair any inconsistencies found during the check. "-r leaks" repairs only cluster leaks, whereas "-r all" fixes all kinds of errors, with a higher risk of choosing the wrong fix or hiding corruption that has already occurred.

    Only the formats "qcow2", "qed" and "vdi" support consistency checks.

create [-f fmt] [-o options] filename [size]
    Create the new disk image filename of size size and format fmt. Depending on the file format, you can add one or more options that enable additional features of this format.

    If the option backing_file is specified, then the image will record only the differences from backing_file. No size needs to be specified in this case. backing_file will never be modified unless you use the "commit" monitor command (or qemu-img commit).

    The size can also be specified using the size option with "-o", it doesn't need to be specified separately in this case.

commit [-f fmt] [-t cache] filename
    Commit the changes recorded in filename in its base image.

convert [-c] [-p] [-f fmt] [-t cache] [-O output_fmt] [-o options] [-s snapshot_name] [-S sparse_size] filename [filename2 [...]] output_filename
    Convert the disk image filename or a snapshot snapshot_name to disk image output_filename using format output_fmt. It can be optionally compressed ("-c" option) or use any format specific options like encryption ("-o" option).

    Only the formats "qcow" and "qcow2" support compression. The compression is read-only. It means that if a compressed sector is rewritten, then it is rewritten as uncompressed data.

    Image conversion is also useful to get smaller image when using a growable format such as "qcow" or "cow": the empty sectors are detected and suppressed from the destination image.

    You can use the backing_file option to force the output image to be created as a copy on write image of the specified base image; the backing_file should have the same content as the input's base image, however the path, image format, etc may differ.

info [-f fmt] [--output=ofmt] [--backing-chain] filename
    Give information about the disk image filename. Use it in particular to know the size reserved on disk which can be different from the displayed size. If VM snapshots are stored in the disk image, they are displayed too. The command can output in the format ofmt which is either "human" or "json".

    If a disk image has a backing file chain, information about each disk image in the chain can be recursively enumerated by using the option "--backing-chain".

    For instance, if you have an image chain like:

            base.qcow2 <- snap1.qcow2 <- snap2.qcow2

    To enumerate information about each disk image in the above chain, starting from top to base, do:

            qemu-img info --backing-chain snap2.qcow2

snapshot [-l | -a snapshot | -c snapshot | -d snapshot ] filename
    List, apply, create or delete snapshots in image filename.

rebase [-f fmt] [-t cache] [-p] [-u] -b backing_file [-F backing_fmt] filename
    Changes the backing file of an image. Only the formats "qcow2" and "qed" support changing the backing file.

    The backing file is changed to backing_file and (if the image format of filename supports this) the backing file format is changed to backing_fmt. If backing_file is specified as "" (the empty string), then the image is rebased onto no backing file (i.e. it will exist independently of any backing file).

    There are two different modes in which "rebase" can operate:

    Safe mode
        This is the default mode and performs a real rebase operation. The new backing file may differ from the old one and qemu-img rebase will take care of keeping the guest-visible content of filename unchanged.

        In order to achieve this, any clusters that differ between backing_file and the old backing file of filename are merged into filename before actually changing the backing file.

        Note that the safe mode is an expensive operation, comparable to converting an image. It only works if the old backing file still exists.

    Unsafe mode
        qemu-img uses the unsafe mode if "-u" is specified. In this mode, only the backing file name and format of filename is changed without any checks on the file contents. The user must take care of specifying the correct new backing file, or the guest-visible content of the image will be corrupted.

        This mode is useful for renaming or moving the backing file to somewhere else. It can be used without an accessible old backing file, i.e. you can use it to fix an image whose backing file has already been moved/renamed.

    You can use "rebase" to perform a "diff" operation on two disk images. This can be useful when you have copied or cloned a guest, and you want to get back to a thin image on top of a template or base image.

    Say that "base.img" has been cloned as "modified.img" by copying it, and that the "modified.img" guest has run so there are now some changes compared to "base.img". To construct a thin image called "diff.qcow2" that contains just the differences, do:

            qemu-img create -f qcow2 -b modified.img diff.qcow2
            qemu-img rebase -b base.img diff.qcow2

    At this point, "modified.img" can be discarded, since "base.img + diff.qcow2" contains the same information.

resize filename [+ | -]size
    Change the disk image as if it had been created with size.

    Before using this command to shrink a disk image, you MUST use file system and partitioning tools inside the VM to reduce allocated file systems and partition sizes accordingly. Failure to do so will result in data loss!

    After using this command to grow a disk image, you must use file system and partitioning tools inside the VM to actually begin using the new space on the device.

NOTES
Supported image file formats:

raw Raw disk image format (default). This format has the advantage of being simple and easily exportable to all other emulators. If your file system supports holes (for example in ext2 or ext3 on Linux or NTFS on Windows), then only the written sectors will reserve space. Use "qemu-img info" to know the real size used by the image or "ls -ls" on Unix/Linux.

qcow2
    QEMU image format, the most versatile format. Use it to have smaller images (useful if your filesystem does not supports holes, for example on Windows), optional AES encryption, zlib based compression and support of multiple VM snapshots.

    Supported options:

    "compat"
        Determines the qcow2 version to use. "compat=0.10" uses the traditional image format that can be read by any QEMU since 0.10 (this is the default). "compat=1.1" enables image format extensions that only QEMU 1.1 and newer understand. Amongst others, this includes zero clusters, which allow efficient copy-on-read for sparse images.

    "backing_file"
        File name of a base image (see create subcommand)

    "backing_fmt"
        Image format of the base image

    "encryption"
        If this option is set to "on", the image is encrypted.

        Encryption uses the AES format which is very secure (128 bit keys). Use a long password (16 characters) to get maximum protection.

    "cluster_size"
        Changes the qcow2 cluster size (must be between 512 and 2M). Smaller cluster sizes can improve the image file size whereas larger cluster sizes generally provide better performance.

    "preallocation"
        Preallocation mode (allowed values: off, metadata). An image with preallocated metadata is initially larger but can improve performance when the image needs to grow.

    "lazy_refcounts"
        If this option is set to "on", reference count updates are postponed with the goal of avoiding metadata I/O and improving performance. This is particularly interesting with cache=writethrough which doesn't batch metadata updates. The tradeoff is that after a host crash, the reference count tables must be rebuilt, i.e. on the next open an (automatic) "qemu-img check -r all" is required, which may take some time.

        This option can only be enabled if "compat=1.1" is specified.

Other
    QEMU also supports various other image file formats for compatibility with older QEMU versions or other hypervisors, including VMDK, VDI, VHD (vpc), qcow1 and QED. For a full list of supported formats see "qemu-img --help". For a more detailed description of these formats, see the QEMU Emulation User Documentation.

    The main purpose of the block drivers for these formats is image conversion. For running VMs, it is recommended to convert the disk images to either raw or qcow2 in order to achieve good performance.

SEE ALSO
The HTML documentation of QEMU for more precise information and Linux user mode emulator invocation.

AUTHOR
Fabrice Bellard